Index: trunk/tools/win.amd64/exports/xp64/oleaut32.dll.exports
===================================================================
--- trunk/tools/win.amd64/exports/xp64/oleaut32.dll.exports	(revision 70365)
+++ trunk/tools/win.amd64/exports/xp64/oleaut32.dll.exports	(revision 70365)
@@ -0,0 +1,828 @@
+;
+; Generated from: :iprtvfs:file(vd,d:\VMs\xp64\w2k3.vdi):vfs(dvm):file(open,vol0):vfs(mount):/windows/system32/oleaut32.dll
+;      Size file: 0x110800 (1116160)
+;         Format: PE
+;  Size of image: 0x114000 (1130496)
+;   Architecture: AMD64
+;      Timestamp: 0x42438b4c - 2005-03-25T03:53:48
+;
+SysAllocString
+#2
+SysReAllocString
+#3
+SysAllocStringLen
+#4
+SysReAllocStringLen
+#5
+SysFreeString
+#6
+SysStringLen
+#7
+VariantInit
+#8
+VariantClear
+#9
+VariantCopy
+#10
+VariantCopyInd
+#11
+VariantChangeType
+#12
+VariantTimeToDosDateTime
+#13
+DosDateTimeToVariantTime
+#14
+SafeArrayCreate
+#15
+SafeArrayDestroy
+#16
+SafeArrayGetDim
+#17
+SafeArrayGetElemsize
+#18
+SafeArrayGetUBound
+#19
+SafeArrayGetLBound
+#20
+SafeArrayLock
+#21
+SafeArrayUnlock
+#22
+SafeArrayAccessData
+#23
+SafeArrayUnaccessData
+#24
+SafeArrayGetElement
+#25
+SafeArrayPutElement
+#26
+SafeArrayCopy
+#27
+DispGetParam
+#28
+DispGetIDsOfNames
+#29
+DispInvoke
+#30
+CreateDispTypeInfo
+#31
+CreateStdDispatch
+#32
+RegisterActiveObject
+#33
+RevokeActiveObject
+#34
+GetActiveObject
+#35
+SafeArrayAllocDescriptor
+#36
+SafeArrayAllocData
+#37
+SafeArrayDestroyDescriptor
+#38
+SafeArrayDestroyData
+#39
+SafeArrayRedim
+#40
+SafeArrayAllocDescriptorEx
+#41
+SafeArrayCreateEx
+#42
+SafeArrayCreateVectorEx
+#43
+SafeArraySetRecordInfo
+#44
+SafeArrayGetRecordInfo
+#45
+VarParseNumFromStr
+#46
+VarNumFromParseNum
+#47
+VarI2FromUI1
+#48
+VarI2FromI4
+#49
+VarI2FromR4
+#50
+VarI2FromR8
+#51
+VarI2FromCy
+#52
+VarI2FromDate
+#53
+VarI2FromStr
+#54
+VarI2FromDisp
+#55
+VarI2FromBool
+#56
+SafeArraySetIID
+#57
+VarI4FromUI1
+#58
+VarI4FromI2
+#59
+VarI4FromR4
+#60
+VarI4FromR8
+#61
+VarI4FromCy
+#62
+VarI4FromDate
+#63
+VarI4FromStr
+#64
+VarI4FromDisp
+#65
+VarI4FromBool
+#66
+SafeArrayGetIID
+#67
+VarR4FromUI1
+#68
+VarR4FromI2
+#69
+VarR4FromI4
+#70
+VarR4FromR8
+#71
+VarR4FromCy
+#72
+VarR4FromDate
+#73
+VarR4FromStr
+#74
+VarR4FromDisp
+#75
+VarR4FromBool
+#76
+SafeArrayGetVartype
+#77
+VarR8FromUI1
+#78
+VarR8FromI2
+#79
+VarR8FromI4
+#80
+VarR8FromR4
+#81
+VarR8FromCy
+#82
+VarR8FromDate
+#83
+VarR8FromStr
+#84
+VarR8FromDisp
+#85
+VarR8FromBool
+#86
+VarFormat
+#87
+VarDateFromUI1
+#88
+VarDateFromI2
+#89
+VarDateFromI4
+#90
+VarDateFromR4
+#91
+VarDateFromR8
+#92
+VarDateFromCy
+#93
+VarDateFromStr
+#94
+VarDateFromDisp
+#95
+VarDateFromBool
+#96
+VarFormatDateTime
+#97
+VarCyFromUI1
+#98
+VarCyFromI2
+#99
+VarCyFromI4
+#100
+VarCyFromR4
+#101
+VarCyFromR8
+#102
+VarCyFromDate
+#103
+VarCyFromStr
+#104
+VarCyFromDisp
+#105
+VarCyFromBool
+#106
+VarFormatNumber
+#107
+VarBstrFromUI1
+#108
+VarBstrFromI2
+#109
+VarBstrFromI4
+#110
+VarBstrFromR4
+#111
+VarBstrFromR8
+#112
+VarBstrFromCy
+#113
+VarBstrFromDate
+#114
+VarBstrFromDisp
+#115
+VarBstrFromBool
+#116
+VarFormatPercent
+#117
+VarBoolFromUI1
+#118
+VarBoolFromI2
+#119
+VarBoolFromI4
+#120
+VarBoolFromR4
+#121
+VarBoolFromR8
+#122
+VarBoolFromDate
+#123
+VarBoolFromCy
+#124
+VarBoolFromStr
+#125
+VarBoolFromDisp
+#126
+VarFormatCurrency
+#127
+VarWeekdayName
+#128
+VarMonthName
+#129
+VarUI1FromI2
+#130
+VarUI1FromI4
+#131
+VarUI1FromR4
+#132
+VarUI1FromR8
+#133
+VarUI1FromCy
+#134
+VarUI1FromDate
+#135
+VarUI1FromStr
+#136
+VarUI1FromDisp
+#137
+VarUI1FromBool
+#138
+VarFormatFromTokens
+#139
+VarTokenizeFormatString
+#140
+VarAdd
+#141
+VarAnd
+#142
+VarDiv
+#143
+BSTR_UserFree64
+#144
+BSTR_UserMarshal64
+#145
+DispCallFunc
+#146
+VariantChangeTypeEx
+#147
+SafeArrayPtrOfIndex
+#148
+SysStringByteLen
+#149
+SysAllocStringByteLen
+#150
+BSTR_UserSize64
+#151
+VarEqv
+#152
+VarIdiv
+#153
+VarImp
+#154
+VarMod
+#155
+VarMul
+#156
+VarOr
+#157
+VarPow
+#158
+VarSub
+#159
+CreateTypeLib
+#160
+LoadTypeLib
+#161
+LoadRegTypeLib
+#162
+RegisterTypeLib
+#163
+QueryPathOfRegTypeLib
+#164
+LHashValOfNameSys
+#165
+LHashValOfNameSysA
+#166
+VarXor
+#167
+VarAbs
+#168
+VarFix
+#169
+OaBuildVersion
+#170
+ClearCustData
+#171
+VarInt
+#172
+VarNeg
+#173
+VarNot
+#174
+VarRound
+#175
+VarCmp
+#176
+VarDecAdd
+#177
+VarDecDiv
+#178
+VarDecMul
+#179
+CreateTypeLib2
+#180
+VarDecSub
+#181
+VarDecAbs
+#182
+LoadTypeLibEx
+#183
+SystemTimeToVariantTime
+#184
+VariantTimeToSystemTime
+#185
+UnRegisterTypeLib
+#186
+VarDecFix
+#187
+VarDecInt
+#188
+VarDecNeg
+#189
+VarDecFromUI1
+#190
+VarDecFromI2
+#191
+VarDecFromI4
+#192
+VarDecFromR4
+#193
+VarDecFromR8
+#194
+VarDecFromDate
+#195
+VarDecFromCy
+#196
+VarDecFromStr
+#197
+VarDecFromDisp
+#198
+VarDecFromBool
+#199
+GetErrorInfo
+#200
+SetErrorInfo
+#201
+CreateErrorInfo
+#202
+VarDecRound
+#203
+VarDecCmp
+#204
+VarI2FromI1
+#205
+VarI2FromUI2
+#206
+VarI2FromUI4
+#207
+VarI2FromDec
+#208
+VarI4FromI1
+#209
+VarI4FromUI2
+#210
+VarI4FromUI4
+#211
+VarI4FromDec
+#212
+VarR4FromI1
+#213
+VarR4FromUI2
+#214
+VarR4FromUI4
+#215
+VarR4FromDec
+#216
+VarR8FromI1
+#217
+VarR8FromUI2
+#218
+VarR8FromUI4
+#219
+VarR8FromDec
+#220
+VarDateFromI1
+#221
+VarDateFromUI2
+#222
+VarDateFromUI4
+#223
+VarDateFromDec
+#224
+VarCyFromI1
+#225
+VarCyFromUI2
+#226
+VarCyFromUI4
+#227
+VarCyFromDec
+#228
+VarBstrFromI1
+#229
+VarBstrFromUI2
+#230
+VarBstrFromUI4
+#231
+VarBstrFromDec
+#232
+VarBoolFromI1
+#233
+VarBoolFromUI2
+#234
+VarBoolFromUI4
+#235
+VarBoolFromDec
+#236
+VarUI1FromI1
+#237
+VarUI1FromUI2
+#238
+VarUI1FromUI4
+#239
+VarUI1FromDec
+#240
+VarDecFromI1
+#241
+VarDecFromUI2
+#242
+VarDecFromUI4
+#243
+VarI1FromUI1
+#244
+VarI1FromI2
+#245
+VarI1FromI4
+#246
+VarI1FromR4
+#247
+VarI1FromR8
+#248
+VarI1FromDate
+#249
+VarI1FromCy
+#250
+VarI1FromStr
+#251
+VarI1FromDisp
+#252
+VarI1FromBool
+#253
+VarI1FromUI2
+#254
+VarI1FromUI4
+#255
+VarI1FromDec
+#256
+VarUI2FromUI1
+#257
+VarUI2FromI2
+#258
+VarUI2FromI4
+#259
+VarUI2FromR4
+#260
+VarUI2FromR8
+#261
+VarUI2FromDate
+#262
+VarUI2FromCy
+#263
+VarUI2FromStr
+#264
+VarUI2FromDisp
+#265
+VarUI2FromBool
+#266
+VarUI2FromI1
+#267
+VarUI2FromUI4
+#268
+VarUI2FromDec
+#269
+VarUI4FromUI1
+#270
+VarUI4FromI2
+#271
+VarUI4FromI4
+#272
+VarUI4FromR4
+#273
+VarUI4FromR8
+#274
+VarUI4FromDate
+#275
+VarUI4FromCy
+#276
+VarUI4FromStr
+#277
+VarUI4FromDisp
+#278
+VarUI4FromBool
+#279
+VarUI4FromI1
+#280
+VarUI4FromUI2
+#281
+VarUI4FromDec
+#282
+BSTR_UserSize
+#283
+BSTR_UserMarshal
+#284
+BSTR_UserUnmarshal
+#285
+BSTR_UserFree
+#286
+VARIANT_UserSize
+#287
+VARIANT_UserMarshal
+#288
+VARIANT_UserUnmarshal
+#289
+VARIANT_UserFree
+#290
+LPSAFEARRAY_UserSize
+#291
+LPSAFEARRAY_UserMarshal
+#292
+LPSAFEARRAY_UserUnmarshal
+#293
+LPSAFEARRAY_UserFree
+#294
+LPSAFEARRAY_Size
+#295
+LPSAFEARRAY_Marshal
+#296
+LPSAFEARRAY_Unmarshal
+#297
+VarDecCmpR8
+#298
+VarCyAdd
+#299
+BSTR_UserUnmarshal64
+#300
+DllCanUnloadNow
+#301
+DllGetClassObject
+#302
+VarCyMul
+#303
+VarCyMulI4
+#304
+VarCySub
+#305
+VarCyAbs
+#306
+VarCyFix
+#307
+VarCyInt
+#308
+VarCyNeg
+#309
+VarCyRound
+#310
+VarCyCmp
+#311
+VarCyCmpR8
+#312
+VarBstrCat
+#313
+VarBstrCmp
+#314
+VarR8Pow
+#315
+VarR4CmpR8
+#316
+VarR8Round
+#317
+VarCat
+#318
+VarDateFromUdateEx
+#319
+DllRegisterServer
+#320
+DllUnregisterServer
+#321
+GetRecordInfoFromGuids
+#322
+GetRecordInfoFromTypeInfo
+#323
+LPSAFEARRAY_UserFree64
+#324
+SetVarConversionLocaleSetting
+#325
+GetVarConversionLocaleSetting
+#326
+SetOaNoCache
+#327
+LPSAFEARRAY_UserMarshal64
+#328
+VarCyMulI8
+#329
+VarDateFromUdate
+#330
+VarUdateFromDate
+#331
+GetAltMonthNames
+#332
+VarI8FromUI1
+#333
+VarI8FromI2
+#334
+VarI8FromR4
+#335
+VarI8FromR8
+#336
+VarI8FromCy
+#337
+VarI8FromDate
+#338
+VarI8FromStr
+#339
+VarI8FromDisp
+#340
+VarI8FromBool
+#341
+VarI8FromI1
+#342
+VarI8FromUI2
+#343
+VarI8FromUI4
+#344
+VarI8FromDec
+#345
+VarI2FromI8
+#346
+VarI2FromUI8
+#347
+VarI4FromI8
+#348
+VarI4FromUI8
+#349
+LPSAFEARRAY_UserSize64
+#350
+LPSAFEARRAY_UserUnmarshal64
+#351
+OACreateTypeLib2
+#352
+VARIANT_UserFree64
+#353
+VARIANT_UserMarshal64
+#354
+VARIANT_UserSize64
+#355
+VARIANT_UserUnmarshal64
+#356
+VarR4FromI8
+#360
+VarR4FromUI8
+#361
+VarR8FromI8
+#362
+VarR8FromUI8
+#363
+VarDateFromI8
+#364
+VarDateFromUI8
+#365
+VarCyFromI8
+#366
+VarCyFromUI8
+#367
+VarBstrFromI8
+#368
+VarBstrFromUI8
+#369
+VarBoolFromI8
+#370
+VarBoolFromUI8
+#371
+VarUI1FromI8
+#372
+VarUI1FromUI8
+#373
+VarDecFromI8
+#374
+VarDecFromUI8
+#375
+VarI1FromI8
+#376
+VarI1FromUI8
+#377
+VarUI2FromI8
+#378
+VarUI2FromUI8
+#379
+OleLoadPictureEx
+#401
+OleLoadPictureFileEx
+#402
+SafeArrayCreateVector
+#411
+SafeArrayCopyData
+#412
+VectorFromBstr
+#413
+BstrFromVector
+#414
+OleIconToCursor
+#415
+OleCreatePropertyFrameIndirect
+#416
+OleCreatePropertyFrame
+#417
+OleLoadPicture
+#418
+OleCreatePictureIndirect
+#419
+OleCreateFontIndirect
+#420
+OleTranslateColor
+#421
+OleLoadPictureFile
+#422
+OleSavePictureFile
+#423
+OleLoadPicturePath
+#424
+VarUI4FromI8
+#425
+VarUI4FromUI8
+#426
+VarI8FromUI8
+#427
+VarUI8FromI8
+#428
+VarUI8FromUI1
+#429
+VarUI8FromI2
+#430
+VarUI8FromR4
+#431
+VarUI8FromR8
+#432
+VarUI8FromCy
+#433
+VarUI8FromDate
+#434
+VarUI8FromStr
+#435
+VarUI8FromDisp
+#436
+VarUI8FromBool
+#437
+VarUI8FromI1
+#438
+VarUI8FromUI2
+#439
+VarUI8FromUI4
+#440
+VarUI8FromDec
+#441
+RegisterTypeLibForUser
+#442
+UnRegisterTypeLibForUser
+#443
Index: trunk/tools/win.amd64/exports/xp64/rpcrt4.dll.exports
===================================================================
--- trunk/tools/win.amd64/exports/xp64/rpcrt4.dll.exports	(revision 70365)
+++ trunk/tools/win.amd64/exports/xp64/rpcrt4.dll.exports	(revision 70365)
@@ -0,0 +1,520 @@
+;
+; Generated from: :iprtvfs:file(vd,d:\VMs\xp64\w2k3.vdi):vfs(dvm):file(open,vol0):vfs(mount):/windows/system32/rpcrt4.dll
+;      Size file: 0x1a2800 (1714176)
+;         Format: PE
+;  Size of image: 0x1a9000 (1740800)
+;   Architecture: AMD64
+;      Timestamp: 0x42438b4b - 2005-03-25T03:53:47
+;
+CreateProxyFromTypeInfo
+CreateStubFromTypeInfo
+I_RpcServerTurnOnOffKeepalives
+CStdStubBuffer_AddRef
+CStdStubBuffer_Connect
+CStdStubBuffer_CountRefs
+CStdStubBuffer_DebugServerQueryInterface
+CStdStubBuffer_DebugServerRelease
+CStdStubBuffer_Disconnect
+CStdStubBuffer_Invoke
+CStdStubBuffer_IsIIDSupported
+CStdStubBuffer_QueryInterface
+DceErrorInqTextA
+DceErrorInqTextW
+DllGetClassObject
+DllInstall
+DllRegisterServer
+GlobalMutexClearExternal
+GlobalMutexRequestExternal
+IUnknown_AddRef_Proxy
+IUnknown_QueryInterface_Proxy
+IUnknown_Release_Proxy
+I_RpcAbortAsyncCall
+I_RpcAllocate
+I_RpcAsyncAbortCall
+I_RpcAsyncSetHandle
+I_RpcBCacheAllocate
+I_RpcBCacheFree
+I_RpcBindingCopy
+I_RpcBindingHandleToAsyncHandle
+I_RpcBindingInqConnId
+I_RpcBindingInqDynamicEndpoint
+I_RpcBindingInqDynamicEndpointA
+I_RpcBindingInqDynamicEndpointW
+I_RpcBindingInqLocalClientPID
+I_RpcBindingInqMarshalledTargetInfo
+I_RpcBindingInqSecurityContext
+I_RpcBindingInqTransportType
+I_RpcBindingInqWireIdForSnego
+I_RpcBindingIsClientLocal
+I_RpcBindingToStaticStringBindingW
+I_RpcClearMutex
+I_RpcConnectionInqSockBuffSize
+I_RpcConnectionSetSockBuffSize
+I_RpcDeleteMutex
+I_RpcEnableWmiTrace
+I_RpcExceptionFilter
+I_RpcFree
+I_RpcFreeBuffer
+I_RpcFreePipeBuffer
+I_RpcGetBuffer
+I_RpcGetBufferWithObject
+I_RpcGetCurrentCallHandle
+I_RpcGetExtendedError
+I_RpcIfInqTransferSyntaxes
+I_RpcLogEvent
+I_RpcMapWin32Status
+I_RpcNDRCGetWireRepresentation
+I_RpcNDRSContextEmergencyCleanup
+I_RpcNegotiateTransferSyntax
+I_RpcNsBindingSetEntryName
+I_RpcNsBindingSetEntryNameA
+I_RpcNsBindingSetEntryNameW
+I_RpcNsInterfaceExported
+I_RpcNsInterfaceUnexported
+I_RpcParseSecurity
+I_RpcPauseExecution
+I_RpcProxyNewConnection
+I_RpcReallocPipeBuffer
+I_RpcReceive
+I_RpcRecordCalloutFailure
+I_RpcReplyToClientWithStatus
+I_RpcRequestMutex
+I_RpcSNCHOption
+I_RpcSend
+I_RpcSendReceive
+I_RpcServerAllocateIpPort
+I_RpcServerCheckClientRestriction
+I_RpcServerInqAddressChangeFn
+I_RpcServerInqLocalConnAddress
+I_RpcServerInqTransportType
+I_RpcServerIsClientDisconnected
+I_RpcServerRegisterForwardFunction
+I_RpcServerSetAddressChangeFn
+I_RpcServerUseProtseq2A
+I_RpcServerUseProtseq2W
+I_RpcServerUseProtseqEp2A
+I_RpcServerUseProtseqEp2W
+I_RpcSessionStrictContextHandle
+I_RpcSetAsyncHandle
+I_RpcSsDontSerializeContext
+I_RpcSystemFunction001
+I_RpcTransConnectionAllocatePacket
+I_RpcTransConnectionFreePacket
+I_RpcTransConnectionReallocPacket
+I_RpcTransDatagramAllocate
+I_RpcTransDatagramAllocate2
+I_RpcTransDatagramFree
+I_RpcTransGetThreadEvent
+I_RpcTransIoCancelled
+I_RpcTransServerNewConnection
+I_RpcTurnOnEEInfoPropagation
+I_UuidCreate
+MesBufferHandleReset
+MesDecodeBufferHandleCreate
+MesDecodeIncrementalHandleCreate
+MesEncodeDynBufferHandleCreate
+MesEncodeFixedBufferHandleCreate
+MesEncodeIncrementalHandleCreate
+MesHandleFree
+MesIncrementalHandleReset
+MesInqProcEncodingId
+NDRCContextBinding
+NDRCContextMarshall
+NDRCContextUnmarshall
+NDRSContextMarshall
+NDRSContextMarshall2
+NDRSContextMarshallEx
+NDRSContextUnmarshall
+NDRSContextUnmarshall2
+NDRSContextUnmarshallEx
+Ndr64AsyncClientCall
+Ndr64AsyncServerCall64
+Ndr64AsyncServerCallAll
+Ndr64DcomAsyncClientCall
+Ndr64DcomAsyncStubCall
+NdrAllocate
+NdrAsyncClientCall
+NdrAsyncServerCall
+NdrByteCountPointerBufferSize
+NdrByteCountPointerFree
+NdrByteCountPointerMarshall
+NdrByteCountPointerUnmarshall
+NdrCStdStubBuffer2_Release
+NdrCStdStubBuffer_Release
+NdrClearOutParameters
+NdrClientCall2
+NdrClientCall3
+NdrClientContextMarshall
+NdrClientContextUnmarshall
+NdrClientInitialize
+NdrClientInitializeNew
+NdrComplexArrayBufferSize
+NdrComplexArrayFree
+NdrComplexArrayMarshall
+NdrComplexArrayMemorySize
+NdrComplexArrayUnmarshall
+NdrComplexStructBufferSize
+NdrComplexStructFree
+NdrComplexStructMarshall
+NdrComplexStructMemorySize
+NdrComplexStructUnmarshall
+NdrConformantArrayBufferSize
+NdrConformantArrayFree
+NdrConformantArrayMarshall
+NdrConformantArrayMemorySize
+NdrConformantArrayUnmarshall
+NdrConformantStringBufferSize
+NdrConformantStringMarshall
+NdrConformantStringMemorySize
+NdrConformantStringUnmarshall
+NdrConformantStructBufferSize
+NdrConformantStructFree
+NdrConformantStructMarshall
+NdrConformantStructMemorySize
+NdrConformantStructUnmarshall
+NdrConformantVaryingArrayBufferSize
+NdrConformantVaryingArrayFree
+NdrConformantVaryingArrayMarshall
+NdrConformantVaryingArrayMemorySize
+NdrConformantVaryingArrayUnmarshall
+NdrConformantVaryingStructBufferSize
+NdrConformantVaryingStructFree
+NdrConformantVaryingStructMarshall
+NdrConformantVaryingStructMemorySize
+NdrConformantVaryingStructUnmarshall
+NdrContextHandleInitialize
+NdrContextHandleSize
+NdrConvert
+NdrConvert2
+NdrCorrelationFree
+NdrCorrelationInitialize
+NdrCorrelationPass
+NdrCreateServerInterfaceFromStub
+NdrDcomAsyncClientCall
+NdrDcomAsyncStubCall
+NdrDllCanUnloadNow
+NdrDllGetClassObject
+NdrDllRegisterProxy
+NdrDllUnregisterProxy
+NdrEncapsulatedUnionBufferSize
+NdrEncapsulatedUnionFree
+NdrEncapsulatedUnionMarshall
+NdrEncapsulatedUnionMemorySize
+NdrEncapsulatedUnionUnmarshall
+NdrFixedArrayBufferSize
+NdrFixedArrayFree
+NdrFixedArrayMarshall
+NdrFixedArrayMemorySize
+NdrFixedArrayUnmarshall
+NdrFreeBuffer
+NdrFullPointerFree
+NdrFullPointerInsertRefId
+NdrFullPointerQueryPointer
+NdrFullPointerQueryRefId
+NdrFullPointerXlatFree
+NdrFullPointerXlatInit
+NdrGetBuffer
+NdrGetDcomProtocolVersion
+NdrGetSimpleTypeBufferAlignment
+NdrGetSimpleTypeBufferSize
+NdrGetSimpleTypeMemorySize
+NdrGetTypeFlags
+NdrGetUserMarshalInfo
+NdrInterfacePointerBufferSize
+NdrInterfacePointerFree
+NdrInterfacePointerMarshall
+NdrInterfacePointerMemorySize
+NdrInterfacePointerUnmarshall
+NdrMapCommAndFaultStatus
+NdrMesProcEncodeDecode
+NdrMesProcEncodeDecode2
+NdrMesProcEncodeDecode3
+NdrMesSimpleTypeAlignSize
+NdrMesSimpleTypeAlignSizeAll
+NdrMesSimpleTypeDecode
+NdrMesSimpleTypeDecodeAll
+NdrMesSimpleTypeEncode
+NdrMesSimpleTypeEncodeAll
+NdrMesTypeAlignSize
+NdrMesTypeAlignSize2
+NdrMesTypeAlignSize3
+NdrMesTypeDecode
+NdrMesTypeDecode2
+NdrMesTypeDecode3
+NdrMesTypeEncode
+NdrMesTypeEncode2
+NdrMesTypeEncode3
+NdrMesTypeFree2
+NdrMesTypeFree3
+NdrNonConformantStringBufferSize
+NdrNonConformantStringMarshall
+NdrNonConformantStringMemorySize
+NdrNonConformantStringUnmarshall
+NdrNonEncapsulatedUnionBufferSize
+NdrNonEncapsulatedUnionFree
+NdrNonEncapsulatedUnionMarshall
+NdrNonEncapsulatedUnionMemorySize
+NdrNonEncapsulatedUnionUnmarshall
+NdrNsGetBuffer
+NdrNsSendReceive
+NdrOleAllocate
+NdrOleFree
+NdrOutInit
+NdrPartialIgnoreClientBufferSize
+NdrPartialIgnoreClientMarshall
+NdrPartialIgnoreServerInitialize
+NdrPartialIgnoreServerUnmarshall
+NdrPointerBufferSize
+NdrPointerFree
+NdrPointerMarshall
+NdrPointerMemorySize
+NdrPointerUnmarshall
+NdrProxyErrorHandler
+NdrProxyFreeBuffer
+NdrProxyGetBuffer
+NdrProxyInitialize
+NdrProxySendReceive
+NdrRangeUnmarshall
+NdrRpcSmClientAllocate
+NdrRpcSmClientFree
+NdrRpcSmSetClientToOsf
+NdrRpcSsDefaultAllocate
+NdrRpcSsDefaultFree
+NdrRpcSsDisableAllocate
+NdrRpcSsEnableAllocate
+NdrSendReceive
+NdrServerCall2
+NdrServerCallAll
+NdrServerCallNdr64
+NdrServerContextMarshall
+NdrServerContextNewMarshall
+NdrServerContextNewUnmarshall
+NdrServerContextUnmarshall
+NdrServerInitialize
+NdrServerInitializeMarshall
+NdrServerInitializeNew
+NdrServerInitializePartial
+NdrServerInitializeUnmarshall
+NdrSimpleStructBufferSize
+NdrSimpleStructFree
+NdrSimpleStructMarshall
+NdrSimpleStructMemorySize
+NdrSimpleStructUnmarshall
+NdrSimpleTypeMarshall
+NdrSimpleTypeUnmarshall
+NdrStubCall2
+NdrStubCall3
+NdrStubForwardingFunction
+NdrStubGetBuffer
+NdrStubInitialize
+NdrStubInitializeMarshall
+NdrTypeFlags
+NdrTypeFree
+NdrTypeMarshall
+NdrTypeSize
+NdrTypeUnmarshall
+NdrUnmarshallBasetypeInline
+NdrUserMarshalBufferSize
+NdrUserMarshalFree
+NdrUserMarshalMarshall
+NdrUserMarshalMemorySize
+NdrUserMarshalSimpleTypeConvert
+NdrUserMarshalUnmarshall
+NdrVaryingArrayBufferSize
+NdrVaryingArrayFree
+NdrVaryingArrayMarshall
+NdrVaryingArrayMemorySize
+NdrVaryingArrayUnmarshall
+NdrXmitOrRepAsBufferSize
+NdrXmitOrRepAsFree
+NdrXmitOrRepAsMarshall
+NdrXmitOrRepAsMemorySize
+NdrXmitOrRepAsUnmarshall
+NdrpCreateProxy
+NdrpCreateStub
+NdrpGetProcFormatString
+NdrpGetTypeFormatString
+NdrpGetTypeGenCookie
+NdrpMemoryIncrement
+NdrpReleaseTypeFormatString
+NdrpReleaseTypeGenCookie
+NdrpSetRpcSsDefaults
+NdrpVarVtOfTypeDesc
+RpcAbortAsyncCall
+RpcAsyncAbortCall
+RpcAsyncCancelCall
+RpcAsyncCompleteCall
+RpcAsyncGetCallStatus
+RpcAsyncInitializeHandle
+RpcAsyncRegisterInfo
+RpcBindingCopy
+RpcBindingFree
+RpcBindingFromStringBindingA
+RpcBindingFromStringBindingW
+RpcBindingInqAuthClientA
+RpcBindingInqAuthClientExA
+RpcBindingInqAuthClientExW
+RpcBindingInqAuthClientW
+RpcBindingInqAuthInfoA
+RpcBindingInqAuthInfoExA
+RpcBindingInqAuthInfoExW
+RpcBindingInqAuthInfoW
+RpcBindingInqObject
+RpcBindingInqOption
+RpcBindingReset
+RpcBindingServerFromClient
+RpcBindingSetAuthInfoA
+RpcBindingSetAuthInfoExA
+RpcBindingSetAuthInfoExW
+RpcBindingSetAuthInfoW
+RpcBindingSetObject
+RpcBindingSetOption
+RpcBindingToStringBindingA
+RpcBindingToStringBindingW
+RpcBindingVectorFree
+RpcCancelAsyncCall
+RpcCancelThread
+RpcCancelThreadEx
+RpcCertGeneratePrincipalNameA
+RpcCertGeneratePrincipalNameW
+RpcCompleteAsyncCall
+RpcEpRegisterA
+RpcEpRegisterNoReplaceA
+RpcEpRegisterNoReplaceW
+RpcEpRegisterW
+RpcEpResolveBinding
+RpcEpUnregister
+RpcErrorAddRecord
+RpcErrorClearInformation
+RpcErrorEndEnumeration
+RpcErrorGetNextRecord
+RpcErrorGetNumberOfRecords
+RpcErrorLoadErrorInfo
+RpcErrorResetEnumeration
+RpcErrorSaveErrorInfo
+RpcErrorStartEnumeration
+RpcFreeAuthorizationContext
+RpcGetAsyncCallStatus
+RpcGetAuthorizationContextForClient
+RpcIfIdVectorFree
+RpcIfInqId
+RpcImpersonateClient
+RpcInitializeAsyncHandle
+RpcMgmtEnableIdleCleanup
+RpcMgmtEpEltInqBegin
+RpcMgmtEpEltInqDone
+RpcMgmtEpEltInqNextA
+RpcMgmtEpEltInqNextW
+RpcMgmtEpUnregister
+RpcMgmtInqComTimeout
+RpcMgmtInqDefaultProtectLevel
+RpcMgmtInqIfIds
+RpcMgmtInqServerPrincNameA
+RpcMgmtInqServerPrincNameW
+RpcMgmtInqStats
+RpcMgmtIsServerListening
+RpcMgmtSetAuthorizationFn
+RpcMgmtSetCancelTimeout
+RpcMgmtSetComTimeout
+RpcMgmtSetServerStackSize
+RpcMgmtStatsVectorFree
+RpcMgmtStopServerListening
+RpcMgmtWaitServerListen
+RpcNetworkInqProtseqsA
+RpcNetworkInqProtseqsW
+RpcNetworkIsProtseqValidA
+RpcNetworkIsProtseqValidW
+RpcNsBindingInqEntryNameA
+RpcNsBindingInqEntryNameW
+RpcObjectInqType
+RpcObjectSetInqFn
+RpcObjectSetType
+RpcProtseqVectorFreeA
+RpcProtseqVectorFreeW
+RpcRaiseException
+RpcRegisterAsyncInfo
+RpcRevertToSelf
+RpcRevertToSelfEx
+RpcServerInqBindings
+RpcServerInqCallAttributesA
+RpcServerInqCallAttributesW
+RpcServerInqDefaultPrincNameA
+RpcServerInqDefaultPrincNameW
+RpcServerInqIf
+RpcServerListen
+RpcServerRegisterAuthInfoA
+RpcServerRegisterAuthInfoW
+RpcServerRegisterIf
+RpcServerRegisterIf2
+RpcServerRegisterIfEx
+RpcServerTestCancel
+RpcServerUnregisterIf
+RpcServerUnregisterIfEx
+RpcServerUseAllProtseqs
+RpcServerUseAllProtseqsEx
+RpcServerUseAllProtseqsIf
+RpcServerUseAllProtseqsIfEx
+RpcServerUseProtseqA
+RpcServerUseProtseqEpA
+RpcServerUseProtseqEpExA
+RpcServerUseProtseqEpExW
+RpcServerUseProtseqEpW
+RpcServerUseProtseqExA
+RpcServerUseProtseqExW
+RpcServerUseProtseqIfA
+RpcServerUseProtseqIfExA
+RpcServerUseProtseqIfExW
+RpcServerUseProtseqIfW
+RpcServerUseProtseqW
+RpcServerYield
+RpcSmAllocate
+RpcSmClientFree
+RpcSmDestroyClientContext
+RpcSmDisableAllocate
+RpcSmEnableAllocate
+RpcSmFree
+RpcSmGetThreadHandle
+RpcSmSetClientAllocFree
+RpcSmSetThreadHandle
+RpcSmSwapClientAllocFree
+RpcSsAllocate
+RpcSsContextLockExclusive
+RpcSsContextLockShared
+RpcSsDestroyClientContext
+RpcSsDisableAllocate
+RpcSsDontSerializeContext
+RpcSsEnableAllocate
+RpcSsFree
+RpcSsGetContextBinding
+RpcSsGetThreadHandle
+RpcSsSetClientAllocFree
+RpcSsSetThreadHandle
+RpcSsSwapClientAllocFree
+RpcStringBindingComposeA
+RpcStringBindingComposeW
+RpcStringBindingParseA
+RpcStringBindingParseW
+RpcStringFreeA
+RpcStringFreeW
+RpcTestCancel
+RpcUserFree
+SimpleTypeAlignment
+SimpleTypeBufferSize
+SimpleTypeMemorySize
+TowerConstruct
+TowerExplode
+UuidCompare
+UuidCreate
+UuidCreateNil
+UuidCreateSequential
+UuidEqual
+UuidFromStringA
+UuidFromStringW
+UuidHash
+UuidIsNil
+UuidToStringA
+UuidToStringW
+pfnFreeRoutines
+pfnMarshallRoutines
+pfnSizeRoutines
+pfnUnmarshallRoutines